summaryrefslogtreecommitdiff
path: root/tests/mv/i-2
diff options
context:
space:
mode:
Diffstat (limited to 'tests/mv/i-2')
-rwxr-xr-xtests/mv/i-277
1 files changed, 77 insertions, 0 deletions
diff --git a/tests/mv/i-2 b/tests/mv/i-2
new file mode 100755
index 0000000..36d1ce4
--- /dev/null
+++ b/tests/mv/i-2
@@ -0,0 +1,77 @@
+#!/bin/sh
+# Test both cp and mv for their behavior with -if and -fi
+# The standards (POSIX and SuS) dictate annoyingly inconsistent behavior.
+
+# Copyright (C) 2000, 2001, 2006, 2007 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ mv --version
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+
+# Make sure we get English translations.
+. $srcdir/../lang-default
+
+PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check
+
+pwd=`pwd`
+tmp=cp-mv-if-$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap 'exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+for i in a b c d e f g h; do
+ echo $i > $i || framework_failure=1
+done
+chmod 0 b d f h || framework_failure=1
+echo y > y || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework'
+ exit 1
+fi
+
+fail=0
+mv -if a b || fail=1
+mv -fi c d < y >/dev/null 2>&1 || fail=1
+
+# Before 4.0s, this would not prompt.
+cp -if e f < y > out 2>&1 || fail=1
+
+# Make sure out contains the prompt.
+case "`cat out`" in
+ "cp: try to overwrite \`f', overriding mode 0000 (---------)?"*) ;;
+ *) fail=1 ;;
+esac
+
+test -f e || fail=1
+test -f f || fail=1
+cmp e f || fail=1
+
+cp -fi g h < y > out 2>&1 || fail=1
+test -f g || fail=1
+test -f h || fail=1
+cmp g h || fail=1
+
+exit $fail